/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

package com.phidget22;
import java.util.*;

public class GyroscopeBase extends Phidget {

	GyroscopeBase(long handle) {
		super(handle);
	}

	public GyroscopeBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableAngularRateUpdateEvents(enable && angularRateUpdateListeners.size() > 0);
	}

	public final void addAngularRateUpdateListener(GyroscopeAngularRateUpdateListener l) {
		synchronized(angularRateUpdateListeners) {
			angularRateUpdateListeners.add(l);
			enableAngularRateUpdateEvents(true);
		}
	}
	private List<GyroscopeAngularRateUpdateListener> angularRateUpdateListeners = new ArrayList<GyroscopeAngularRateUpdateListener>();
	private long nativeAngularRateUpdateHandler = 0;
	public final void removeAngularRateUpdateListener(GyroscopeAngularRateUpdateListener l) {
		synchronized(angularRateUpdateListeners) {
			angularRateUpdateListeners.remove(l);
			enableAngularRateUpdateEvents(angularRateUpdateListeners.size() > 0);
		}
	}
	private void fireAngularRateUpdate(GyroscopeAngularRateUpdateEvent e) {
		synchronized(angularRateUpdateListeners) {
			for (Iterator it = angularRateUpdateListeners.iterator (); it.hasNext();)
			((GyroscopeAngularRateUpdateListener) it.next ()).onAngularRateUpdate (e);
		}
	}
	private native void enableAngularRateUpdateEvents(boolean b);


	public native double[] getAngularRate() throws PhidgetException;
	public native double[] getMinAngularRate() throws PhidgetException;
	public native double[] getMaxAngularRate() throws PhidgetException;
	public native int getAxisCount() throws PhidgetException;
	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native boolean getHeatingEnabled() throws PhidgetException;
	public native void setHeatingEnabled(boolean HeatingEnabled) throws PhidgetException;
	public native double getTimestamp() throws PhidgetException;
	public native void zero() throws PhidgetException;
}
