/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

package com.phidget22;
import java.util.*;

public class LightSensorBase extends Phidget {

	LightSensorBase(long handle) {
		super(handle);
	}

	public LightSensorBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableIlluminanceChangeEvents(enable && illuminanceChangeListeners.size() > 0);
	}

	public final void addIlluminanceChangeListener(LightSensorIlluminanceChangeListener l) {
		synchronized(illuminanceChangeListeners) {
			illuminanceChangeListeners.add(l);
			enableIlluminanceChangeEvents(true);
		}
	}
	private List<LightSensorIlluminanceChangeListener> illuminanceChangeListeners = new ArrayList<LightSensorIlluminanceChangeListener>();
	private long nativeIlluminanceChangeHandler = 0;
	public final void removeIlluminanceChangeListener(LightSensorIlluminanceChangeListener l) {
		synchronized(illuminanceChangeListeners) {
			illuminanceChangeListeners.remove(l);
			enableIlluminanceChangeEvents(illuminanceChangeListeners.size() > 0);
		}
	}
	private void fireIlluminanceChange(LightSensorIlluminanceChangeEvent e) {
		synchronized(illuminanceChangeListeners) {
			for (Iterator it = illuminanceChangeListeners.iterator (); it.hasNext();)
			((LightSensorIlluminanceChangeListener) it.next ()).onIlluminanceChange (e);
		}
	}
	private native void enableIlluminanceChangeEvents(boolean b);


	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native double getIlluminance() throws PhidgetException;
	public native double getMinIlluminance() throws PhidgetException;
	public native double getMaxIlluminance() throws PhidgetException;
	public native double getIlluminanceChangeTrigger() throws PhidgetException;
	public native void setIlluminanceChangeTrigger(double IlluminanceChangeTrigger) throws PhidgetException;
	public native double getMinIlluminanceChangeTrigger() throws PhidgetException;
	public native double getMaxIlluminanceChangeTrigger() throws PhidgetException;
}
