/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of Phidget22.jar
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

package com.phidget22;
import java.util.*;

public class SpatialBase extends Phidget {

	SpatialBase(long handle) {
		super(handle);
	}

	public SpatialBase() throws PhidgetException {
		super(create());
	}

	private native static long create() throws PhidgetException;

	private final void setDeviceEvents(boolean enable) {
		enableAlgorithmDataEvents(enable && algorithmDataListeners.size() > 0);
		enableSpatialDataEvents(enable && spatialDataListeners.size() > 0);
	}

	public final void addAlgorithmDataListener(SpatialAlgorithmDataListener l) {
		synchronized(algorithmDataListeners) {
			algorithmDataListeners.add(l);
			enableAlgorithmDataEvents(true);
		}
	}
	private List<SpatialAlgorithmDataListener> algorithmDataListeners = new ArrayList<SpatialAlgorithmDataListener>();
	private long nativeAlgorithmDataHandler = 0;
	public final void removeAlgorithmDataListener(SpatialAlgorithmDataListener l) {
		synchronized(algorithmDataListeners) {
			algorithmDataListeners.remove(l);
			enableAlgorithmDataEvents(algorithmDataListeners.size() > 0);
		}
	}
	private void fireAlgorithmData(SpatialAlgorithmDataEvent e) {
		synchronized(algorithmDataListeners) {
			for (Iterator it = algorithmDataListeners.iterator (); it.hasNext();)
			((SpatialAlgorithmDataListener) it.next ()).onAlgorithmData (e);
		}
	}
	private native void enableAlgorithmDataEvents(boolean b);

	public final void addSpatialDataListener(SpatialSpatialDataListener l) {
		synchronized(spatialDataListeners) {
			spatialDataListeners.add(l);
			enableSpatialDataEvents(true);
		}
	}
	private List<SpatialSpatialDataListener> spatialDataListeners = new ArrayList<SpatialSpatialDataListener>();
	private long nativeSpatialDataHandler = 0;
	public final void removeSpatialDataListener(SpatialSpatialDataListener l) {
		synchronized(spatialDataListeners) {
			spatialDataListeners.remove(l);
			enableSpatialDataEvents(spatialDataListeners.size() > 0);
		}
	}
	private void fireSpatialData(SpatialSpatialDataEvent e) {
		synchronized(spatialDataListeners) {
			for (Iterator it = spatialDataListeners.iterator (); it.hasNext();)
			((SpatialSpatialDataListener) it.next ()).onSpatialData (e);
		}
	}
	private native void enableSpatialDataEvents(boolean b);


	public native void setAHRSParameters(double angularVelocityThreshold, double angularVelocityDeltaThreshold, double accelerationThreshold, double magTime, double accelTime, double biasTime) throws PhidgetException;
	public native SpatialAlgorithm getAlgorithm() throws PhidgetException;
	public native void setAlgorithm(SpatialAlgorithm Algorithm) throws PhidgetException;
	public native double getAlgorithmMagnetometerGain() throws PhidgetException;
	public native void setAlgorithmMagnetometerGain(double AlgorithmMagnetometerGain) throws PhidgetException;
	public native int getDataInterval() throws PhidgetException;
	public native void setDataInterval(int DataInterval) throws PhidgetException;
	public native int getMinDataInterval() throws PhidgetException;
	public native int getMaxDataInterval() throws PhidgetException;
	public native double getDataRate() throws PhidgetException;
	public native void setDataRate(double DataRate) throws PhidgetException;
	public native double getMinDataRate() throws PhidgetException;
	public native double getMaxDataRate() throws PhidgetException;
	public native SpatialEulerAngles getEulerAngles() throws PhidgetException;
	public native boolean getHeatingEnabled() throws PhidgetException;
	public native void setHeatingEnabled(boolean HeatingEnabled) throws PhidgetException;
	public native void setMagnetometerCorrectionParameters(double magneticField, double offset0, double offset1, double offset2, double gain0, double gain1, double gain2, double T0, double T1, double T2, double T3, double T4, double T5) throws PhidgetException;
	public native SpatialQuaternion getQuaternion() throws PhidgetException;
	public native void resetMagnetometerCorrectionParameters() throws PhidgetException;
	public native void saveMagnetometerCorrectionParameters() throws PhidgetException;
	public native void zeroAlgorithm() throws PhidgetException;
	public native void zeroGyro() throws PhidgetException;
}
