/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_AccelerometerBase.h"

static jclass accelerometerbase_class;
jclass accelerometer_class;
jmethodID accelerometer_cons;

static jclass accelerationChangeEvent_class;
static jmethodID fireAccelerationChange_mid	;
static jmethodID accelerationChangeEvent_cons;
static jfieldID nativeAccelerationChangeHandler_fid;

void com_phidget22_AccelerometerBase_OnLoad(JNIEnv *env) {
	if (!(accelerometer_class = (*env)->FindClass(env, "com/phidget22/Accelerometer"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(accelerometer_class = (jclass)(*env)->NewGlobalRef(env, accelerometer_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef accelerometer_class");
	if (!(accelerometer_cons = (*env)->GetMethodID(env, accelerometer_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from accelerometer_class");

	if (!(accelerometerbase_class = (*env)->FindClass(env, "com/phidget22/AccelerometerBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/AccelerometerBase");
	if (!(accelerometerbase_class = (jclass)(*env)->NewGlobalRef(env, accelerometerbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef accelerometerbase_class");

	if ((accelerationChangeEvent_class = (*env)->FindClass(env, "com/phidget22/AccelerometerAccelerationChangeEvent"))) {
		if (!(accelerationChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, accelerationChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref AccelerationChangeEvent_class");
		if (!(fireAccelerationChange_mid = (*env)->GetMethodID(env, accelerometerbase_class, "fireAccelerationChange", "(Lcom/phidget22/AccelerometerAccelerationChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireAccelerationChange");
		if (!(accelerationChangeEvent_cons = (*env)->GetMethodID(env, accelerationChangeEvent_class, "<init>", "(Lcom/phidget22/Accelerometer;[DD)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from AccelerationChangeEvent_class");
		if (!(nativeAccelerationChangeHandler_fid = (*env)->GetFieldID(env, accelerometerbase_class, "nativeAccelerationChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeAccelerationChangeHandler from accelerometerbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_AccelerometerBase_create(JNIEnv * env, jclass obj) {
	PhidgetAccelerometerHandle phid;
	int error; 
	if ((error = PhidgetAccelerometer_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_AccelerometerBase_getAcceleration(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double acceleration[3];
	jdoubleArray jacceleration = (*env)->NewDoubleArray(env, 3);
	ret = PhidgetAccelerometer_getAcceleration(h, &acceleration);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, jacceleration, 0, (jsize)3, acceleration);
	return jacceleration;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_AccelerometerBase_getMinAcceleration(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minAcceleration[3];
	jdoubleArray jminAcceleration = (*env)->NewDoubleArray(env, 3);
	ret = PhidgetAccelerometer_getMinAcceleration(h, &minAcceleration);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, jminAcceleration, 0, (jsize)3, minAcceleration);
	return jminAcceleration;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_AccelerometerBase_getMaxAcceleration(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxAcceleration[3];
	jdoubleArray jmaxAcceleration = (*env)->NewDoubleArray(env, 3);
	ret = PhidgetAccelerometer_getMaxAcceleration(h, &maxAcceleration);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, jmaxAcceleration, 0, (jsize)3, maxAcceleration);
	return jmaxAcceleration;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getAccelerationChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double accelerationChangeTrigger;
	ret = PhidgetAccelerometer_getAccelerationChangeTrigger(h, &accelerationChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return accelerationChangeTrigger;
	}
	return accelerationChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_AccelerometerBase_setAccelerationChangeTrigger(JNIEnv * env, jobject obj, jdouble accelerationChangeTrigger) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetAccelerometer_setAccelerationChangeTrigger(h, (double)accelerationChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getMinAccelerationChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minAccelerationChangeTrigger;
	ret = PhidgetAccelerometer_getMinAccelerationChangeTrigger(h, &minAccelerationChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minAccelerationChangeTrigger;
	}
	return minAccelerationChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getMaxAccelerationChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxAccelerationChangeTrigger;
	ret = PhidgetAccelerometer_getMaxAccelerationChangeTrigger(h, &maxAccelerationChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxAccelerationChangeTrigger;
	}
	return maxAccelerationChangeTrigger;
}

JNIEXPORT jint JNICALL Java_com_phidget22_AccelerometerBase_getAxisCount(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int axisCount;
	ret = PhidgetAccelerometer_getAxisCount(h, &axisCount);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return axisCount;
	}
	return axisCount;
}

JNIEXPORT jint JNICALL Java_com_phidget22_AccelerometerBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetAccelerometer_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_AccelerometerBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetAccelerometer_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_AccelerometerBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetAccelerometer_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_AccelerometerBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetAccelerometer_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetAccelerometer_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_AccelerometerBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetAccelerometer_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetAccelerometer_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetAccelerometer_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_AccelerometerBase_getHeatingEnabled(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int heatingEnabled;
	ret = PhidgetAccelerometer_getHeatingEnabled(h, &heatingEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return heatingEnabled;
	}
	return heatingEnabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_AccelerometerBase_setHeatingEnabled(JNIEnv * env, jobject obj, jboolean heatingEnabled) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetAccelerometer_setHeatingEnabled(h, (int)heatingEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_AccelerometerBase_getTimestamp(JNIEnv * env, jobject obj) {
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double timestamp;
	ret = PhidgetAccelerometer_getTimestamp(h, &timestamp);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return timestamp;
	}
	return timestamp;
}

static void CCONV accelerationChange_handler(PhidgetAccelerometerHandle h, void *arg, const double acceleration[3], double timestamp) {
	jobject accelerationChangeEv;
	JNIEnv *env;
	jobject obj;
	jdoubleArray accelerationArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	accelerationArr = (*env)->NewDoubleArray(env, (jsize)3);
	(*env)->SetDoubleArrayRegion(env, accelerationArr, 0, (jsize)3, acceleration);

	if ((accelerationChangeEv = (*env)->NewObject(env, accelerationChangeEvent_class, accelerationChangeEvent_cons, obj, accelerationArr, timestamp)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireAccelerationChange_mid, accelerationChangeEv);
		(*env)->DeleteLocalRef(env, accelerationChangeEv);
	}
	(*env)->DeleteLocalRef(env, accelerationArr);
}

JNIEXPORT void JNICALL Java_com_phidget22_AccelerometerBase_enableAccelerationChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (accelerationChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/AccelerometerAccelerationChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeAccelerationChangeHandler_fid, b);
	PhidgetAccelerometerHandle h = (PhidgetAccelerometerHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetAccelerometer_setOnAccelerationChangeHandler(h, b ? accelerationChange_handler : NULL, (void *)(uintptr_t) gr);
}
