/*
 * This file is part of libphidget22java
 *
 * Copyright 2015 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_DictionaryBase.h"

extern jfieldID phidget_handle_fid;

void com_phidget22_Dictionary_OnLoad(JNIEnv *env) { }

JNIEXPORT jstring JNICALL Java_com_phidget22_DictionaryBase_get(JNIEnv * env, jobject obj, jstring key) {
	PhidgetDictionaryHandle h = (PhidgetDictionaryHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	int error;
	char value[2048];
	size_t len = 2048;
	const char *keyUTFChars = (key == NULL ? NULL : (*env)->GetStringUTFChars(env, key, NULL));
	if ((error = PhidgetDictionary_get(h, keyUTFChars, value, (size_t)len))) {
		if (error = EPHIDGET_NOENT)
			return NULL;
		PH_THROW_LAST_ERR(error);
		return NULL;
	}
	if (keyUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, key, keyUTFChars);
	return (*env)->NewStringUTF(env, value);
}
