/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_FrequencyCounterBase.h"

static jclass frequencyCounterbase_class;
jclass frequencyCounter_class;
jmethodID frequencyCounter_cons;

static jclass frequencyChangeEvent_class;
static jmethodID fireFrequencyChange_mid	;
static jmethodID frequencyChangeEvent_cons;
static jfieldID nativeFrequencyChangeHandler_fid;

static jclass countChangeEvent_class;
static jmethodID fireCountChange_mid	;
static jmethodID countChangeEvent_cons;
static jfieldID nativeCountChangeHandler_fid;

void com_phidget22_FrequencyCounterBase_OnLoad(JNIEnv *env) {
	if (!(frequencyCounter_class = (*env)->FindClass(env, "com/phidget22/FrequencyCounter"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(frequencyCounter_class = (jclass)(*env)->NewGlobalRef(env, frequencyCounter_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef frequencyCounter_class");
	if (!(frequencyCounter_cons = (*env)->GetMethodID(env, frequencyCounter_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from frequencyCounter_class");

	if (!(frequencyCounterbase_class = (*env)->FindClass(env, "com/phidget22/FrequencyCounterBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FrequencyCounterBase");
	if (!(frequencyCounterbase_class = (jclass)(*env)->NewGlobalRef(env, frequencyCounterbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef frequencyCounterbase_class");

	if ((frequencyChangeEvent_class = (*env)->FindClass(env, "com/phidget22/FrequencyCounterFrequencyChangeEvent"))) {
		if (!(frequencyChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, frequencyChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref FrequencyChangeEvent_class");
		if (!(fireFrequencyChange_mid = (*env)->GetMethodID(env, frequencyCounterbase_class, "fireFrequencyChange", "(Lcom/phidget22/FrequencyCounterFrequencyChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireFrequencyChange");
		if (!(frequencyChangeEvent_cons = (*env)->GetMethodID(env, frequencyChangeEvent_class, "<init>", "(Lcom/phidget22/FrequencyCounter;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from FrequencyChangeEvent_class");
		if (!(nativeFrequencyChangeHandler_fid = (*env)->GetFieldID(env, frequencyCounterbase_class, "nativeFrequencyChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeFrequencyChangeHandler from frequencyCounterbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((countChangeEvent_class = (*env)->FindClass(env, "com/phidget22/FrequencyCounterCountChangeEvent"))) {
		if (!(countChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, countChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref CountChangeEvent_class");
		if (!(fireCountChange_mid = (*env)->GetMethodID(env, frequencyCounterbase_class, "fireCountChange", "(Lcom/phidget22/FrequencyCounterCountChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireCountChange");
		if (!(countChangeEvent_cons = (*env)->GetMethodID(env, countChangeEvent_class, "<init>", "(Lcom/phidget22/FrequencyCounter;JD)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from CountChangeEvent_class");
		if (!(nativeCountChangeHandler_fid = (*env)->GetFieldID(env, frequencyCounterbase_class, "nativeCountChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeCountChangeHandler from frequencyCounterbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_FrequencyCounterBase_create(JNIEnv * env, jclass obj) {
	PhidgetFrequencyCounterHandle phid;
	int error; 
	if ((error = PhidgetFrequencyCounter_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jlong JNICALL Java_com_phidget22_FrequencyCounterBase_getCount(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint64_t count;
	ret = PhidgetFrequencyCounter_getCount(h, &count);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return count;
	}
	return count;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_FrequencyCounterBase_getEnabled(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int enabled;
	ret = PhidgetFrequencyCounter_getEnabled(h, &enabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return enabled;
	}
	return enabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setEnabled(JNIEnv * env, jobject obj, jboolean enabled) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetFrequencyCounter_setEnabled(h, (int)enabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_FrequencyCounterBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetFrequencyCounter_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetFrequencyCounter_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_FrequencyCounterBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetFrequencyCounter_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_FrequencyCounterBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetFrequencyCounter_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetFrequencyCounter_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetFrequencyCounter_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetFrequencyCounter_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetFrequencyCounter_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_FrequencyCounterBase_getFilterType(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetFrequencyCounter_FilterType filterType;
	if (FrequencyFilterType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FrequencyFilterType");
	ret = PhidgetFrequencyCounter_getFilterType(h, &filterType);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, FrequencyFilterType_class, FrequencyFilterType_getEnum_mid, filterType);
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setFilterType(JNIEnv * env, jobject obj, jobject filterType) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (FrequencyFilterType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FrequencyFilterType");
	ret = PhidgetFrequencyCounter_setFilterType(h, (PhidgetFrequencyCounter_FilterType)(*env)->CallIntMethod(env, filterType, FrequencyFilterType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getFrequency(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double frequency;
	ret = PhidgetFrequencyCounter_getFrequency(h, &frequency);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return frequency;
	}
	return frequency;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getMaxFrequency(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxFrequency;
	ret = PhidgetFrequencyCounter_getMaxFrequency(h, &maxFrequency);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxFrequency;
	}
	return maxFrequency;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getFrequencyCutoff(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double frequencyCutoff;
	ret = PhidgetFrequencyCounter_getFrequencyCutoff(h, &frequencyCutoff);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return frequencyCutoff;
	}
	return frequencyCutoff;
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setFrequencyCutoff(JNIEnv * env, jobject obj, jdouble frequencyCutoff) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetFrequencyCounter_setFrequencyCutoff(h, (double)frequencyCutoff);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getMinFrequencyCutoff(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minFrequencyCutoff;
	ret = PhidgetFrequencyCounter_getMinFrequencyCutoff(h, &minFrequencyCutoff);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minFrequencyCutoff;
	}
	return minFrequencyCutoff;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getMaxFrequencyCutoff(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxFrequencyCutoff;
	ret = PhidgetFrequencyCounter_getMaxFrequencyCutoff(h, &maxFrequencyCutoff);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxFrequencyCutoff;
	}
	return maxFrequencyCutoff;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_FrequencyCounterBase_getInputMode(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_InputMode inputMode;
	if (InputMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/InputMode");
	ret = PhidgetFrequencyCounter_getInputMode(h, &inputMode);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, InputMode_class, InputMode_getEnum_mid, inputMode);
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setInputMode(JNIEnv * env, jobject obj, jobject inputMode) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (InputMode_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/InputMode");
	ret = PhidgetFrequencyCounter_setInputMode(h, (Phidget_InputMode)(*env)->CallIntMethod(env, inputMode, InputMode_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_FrequencyCounterBase_getPowerSupply(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_PowerSupply powerSupply;
	if (PowerSupply_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerSupply");
	ret = PhidgetFrequencyCounter_getPowerSupply(h, &powerSupply);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, PowerSupply_class, PowerSupply_getEnum_mid, powerSupply);
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_setPowerSupply(JNIEnv * env, jobject obj, jobject powerSupply) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (PowerSupply_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerSupply");
	ret = PhidgetFrequencyCounter_setPowerSupply(h, (Phidget_PowerSupply)(*env)->CallIntMethod(env, powerSupply, PowerSupply_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_reset(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetFrequencyCounter_reset(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_FrequencyCounterBase_getTimeElapsed(JNIEnv * env, jobject obj) {
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double timeElapsed;
	ret = PhidgetFrequencyCounter_getTimeElapsed(h, &timeElapsed);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return timeElapsed;
	}
	return timeElapsed;
}

static void CCONV countChange_handler(PhidgetFrequencyCounterHandle h, void *arg, uint64_t counts, double timeChange) {
	jobject countChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((countChangeEv = (*env)->NewObject(env, countChangeEvent_class, countChangeEvent_cons, obj, counts, timeChange)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireCountChange_mid, countChangeEv);
		(*env)->DeleteLocalRef(env, countChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_enableCountChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (countChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FrequencyCounterCountChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeCountChangeHandler_fid, b);
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetFrequencyCounter_setOnCountChangeHandler(h, b ? countChange_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV frequencyChange_handler(PhidgetFrequencyCounterHandle h, void *arg, double frequency) {
	jobject frequencyChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((frequencyChangeEv = (*env)->NewObject(env, frequencyChangeEvent_class, frequencyChangeEvent_cons, obj, frequency)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireFrequencyChange_mid, frequencyChangeEv);
		(*env)->DeleteLocalRef(env, frequencyChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_FrequencyCounterBase_enableFrequencyChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (frequencyChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/FrequencyCounterFrequencyChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeFrequencyChangeHandler_fid, b);
	PhidgetFrequencyCounterHandle h = (PhidgetFrequencyCounterHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetFrequencyCounter_setOnFrequencyChangeHandler(h, b ? frequencyChange_handler : NULL, (void *)(uintptr_t) gr);
}
