/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_RFIDBase.h"

static jclass RFIDbase_class;
jclass RFID_class;
jmethodID RFID_cons;

static jclass tagEvent_class;
static jmethodID fireTag_mid	;
static jmethodID tagEvent_cons;
static jfieldID nativeTagHandler_fid;

static jclass tagLostEvent_class;
static jmethodID fireTagLost_mid	;
static jmethodID tagLostEvent_cons;
static jfieldID nativeTagLostHandler_fid;

void com_phidget22_RFIDBase_OnLoad(JNIEnv *env) {
	if (!(RFID_class = (*env)->FindClass(env, "com/phidget22/RFID"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(RFID_class = (jclass)(*env)->NewGlobalRef(env, RFID_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef RFID_class");
	if (!(RFID_cons = (*env)->GetMethodID(env, RFID_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from RFID_class");

	if (!(RFIDbase_class = (*env)->FindClass(env, "com/phidget22/RFIDBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RFIDBase");
	if (!(RFIDbase_class = (jclass)(*env)->NewGlobalRef(env, RFIDbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef RFIDbase_class");

	if ((tagEvent_class = (*env)->FindClass(env, "com/phidget22/RFIDTagEvent"))) {
		if (!(tagEvent_class = (jclass)(*env)->NewGlobalRef(env, tagEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref TagEvent_class");
		if (!(fireTag_mid = (*env)->GetMethodID(env, RFIDbase_class, "fireTag", "(Lcom/phidget22/RFIDTagEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireTag");
		if (!(tagEvent_cons = (*env)->GetMethodID(env, tagEvent_class, "<init>", "(Lcom/phidget22/RFID;Ljava/lang/String;Lcom/phidget22/RFIDProtocol;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from TagEvent_class");
		if (!(nativeTagHandler_fid = (*env)->GetFieldID(env, RFIDbase_class, "nativeTagHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeTagHandler from RFIDbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((tagLostEvent_class = (*env)->FindClass(env, "com/phidget22/RFIDTagLostEvent"))) {
		if (!(tagLostEvent_class = (jclass)(*env)->NewGlobalRef(env, tagLostEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref TagLostEvent_class");
		if (!(fireTagLost_mid = (*env)->GetMethodID(env, RFIDbase_class, "fireTagLost", "(Lcom/phidget22/RFIDTagLostEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireTagLost");
		if (!(tagLostEvent_cons = (*env)->GetMethodID(env, tagLostEvent_class, "<init>", "(Lcom/phidget22/RFID;Ljava/lang/String;Lcom/phidget22/RFIDProtocol;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from TagLostEvent_class");
		if (!(nativeTagLostHandler_fid = (*env)->GetFieldID(env, RFIDbase_class, "nativeTagLostHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeTagLostHandler from RFIDbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_RFIDBase_create(JNIEnv * env, jclass obj) {
	PhidgetRFIDHandle phid;
	int error; 
	if ((error = PhidgetRFID_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_RFIDBase_getAntennaEnabled(JNIEnv * env, jobject obj) {
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int antennaEnabled;
	ret = PhidgetRFID_getAntennaEnabled(h, &antennaEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return antennaEnabled;
	}
	return antennaEnabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_RFIDBase_setAntennaEnabled(JNIEnv * env, jobject obj, jboolean antennaEnabled) {
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetRFID_setAntennaEnabled(h, (int)antennaEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_RFIDBase_getTagPresent(JNIEnv * env, jobject obj) {
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int tagPresent;
	ret = PhidgetRFID_getTagPresent(h, &tagPresent);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return tagPresent;
	}
	return tagPresent;
}

JNIEXPORT void JNICALL Java_com_phidget22_RFIDBase_write(JNIEnv * env, jobject obj, jstring tagString, jobject protocol, jboolean lockTag) {
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	const char *tagStringUTFChars = (tagString == NULL ? NULL : (*env)->GetStringUTFChars(env, tagString, NULL));
	if (RFIDProtocol_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RFIDProtocol");
	ret = PhidgetRFID_write(h, (const char *)tagStringUTFChars, (PhidgetRFID_Protocol)(*env)->CallIntMethod(env, protocol, RFIDProtocol_getCode_mid), (int)lockTag);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		if (tagStringUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, tagString, tagStringUTFChars);
		return;
	}
	if (tagStringUTFChars != NULL) (*env)->ReleaseStringUTFChars(env, tagString, tagStringUTFChars);
}

static void CCONV tag_handler(PhidgetRFIDHandle h, void *arg, const char * tag, PhidgetRFID_Protocol protocol) {
	jobject tagEv;
	JNIEnv *env;
	jobject obj;
	jstring tagStr;
	jobject protocolEnum;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	tagStr = (*env)->NewStringUTF(env, tag);
	if (RFIDProtocol_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RFIDProtocol");
	protocolEnum = (*env)->CallStaticObjectMethod(env, RFIDProtocol_class, RFIDProtocol_getEnum_mid, protocol);

	if ((tagEv = (*env)->NewObject(env, tagEvent_class, tagEvent_cons, obj, tagStr, protocolEnum)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireTag_mid, tagEv);
		(*env)->DeleteLocalRef(env, tagEv);
	}
	(*env)->DeleteLocalRef(env, tagStr);
	(*env)->DeleteLocalRef(env, protocolEnum);
}

JNIEXPORT void JNICALL Java_com_phidget22_RFIDBase_enableTagEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (tagEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RFIDTagEvent");
	jlong gr = updateGlobalRef(env, obj, nativeTagHandler_fid, b);
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetRFID_setOnTagHandler(h, b ? tag_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV tagLost_handler(PhidgetRFIDHandle h, void *arg, const char * tag, PhidgetRFID_Protocol protocol) {
	jobject tagLostEv;
	JNIEnv *env;
	jobject obj;
	jstring tagStr;
	jobject protocolEnum;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	tagStr = (*env)->NewStringUTF(env, tag);
	if (RFIDProtocol_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RFIDProtocol");
	protocolEnum = (*env)->CallStaticObjectMethod(env, RFIDProtocol_class, RFIDProtocol_getEnum_mid, protocol);

	if ((tagLostEv = (*env)->NewObject(env, tagLostEvent_class, tagLostEvent_cons, obj, tagStr, protocolEnum)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireTagLost_mid, tagLostEv);
		(*env)->DeleteLocalRef(env, tagLostEv);
	}
	(*env)->DeleteLocalRef(env, tagStr);
	(*env)->DeleteLocalRef(env, protocolEnum);
}

JNIEXPORT void JNICALL Java_com_phidget22_RFIDBase_enableTagLostEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (tagLostEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/RFIDTagLostEvent");
	jlong gr = updateGlobalRef(env, obj, nativeTagLostHandler_fid, b);
	PhidgetRFIDHandle h = (PhidgetRFIDHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetRFID_setOnTagLostHandler(h, b ? tagLost_handler : NULL, (void *)(uintptr_t) gr);
}
