/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_SoundSensorBase.h"

static jclass soundSensorbase_class;
jclass soundSensor_class;
jmethodID soundSensor_cons;

static jclass SPLChangeEvent_class;
static jmethodID fireSPLChange_mid	;
static jmethodID SPLChangeEvent_cons;
static jfieldID nativeSPLChangeHandler_fid;

void com_phidget22_SoundSensorBase_OnLoad(JNIEnv *env) {
	if (!(soundSensor_class = (*env)->FindClass(env, "com/phidget22/SoundSensor"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(soundSensor_class = (jclass)(*env)->NewGlobalRef(env, soundSensor_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef soundSensor_class");
	if (!(soundSensor_cons = (*env)->GetMethodID(env, soundSensor_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from soundSensor_class");

	if (!(soundSensorbase_class = (*env)->FindClass(env, "com/phidget22/SoundSensorBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/SoundSensorBase");
	if (!(soundSensorbase_class = (jclass)(*env)->NewGlobalRef(env, soundSensorbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef soundSensorbase_class");

	if ((SPLChangeEvent_class = (*env)->FindClass(env, "com/phidget22/SoundSensorSPLChangeEvent"))) {
		if (!(SPLChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, SPLChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref SPLChangeEvent_class");
		if (!(fireSPLChange_mid = (*env)->GetMethodID(env, soundSensorbase_class, "fireSPLChange", "(Lcom/phidget22/SoundSensorSPLChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireSPLChange");
		if (!(SPLChangeEvent_cons = (*env)->GetMethodID(env, SPLChangeEvent_class, "<init>", "(Lcom/phidget22/SoundSensor;DDD[D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from SPLChangeEvent_class");
		if (!(nativeSPLChangeHandler_fid = (*env)->GetFieldID(env, soundSensorbase_class, "nativeSPLChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeSPLChangeHandler from soundSensorbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_SoundSensorBase_create(JNIEnv * env, jclass obj) {
	PhidgetSoundSensorHandle phid;
	int error; 
	if ((error = PhidgetSoundSensor_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_SoundSensorBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetSoundSensor_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_SoundSensorBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSoundSensor_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_SoundSensorBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetSoundSensor_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_SoundSensorBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetSoundSensor_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetSoundSensor_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_SoundSensorBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSoundSensor_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetSoundSensor_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetSoundSensor_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getdB(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dB;
	ret = PhidgetSoundSensor_getdB(h, &dB);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dB;
	}
	return dB;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getMaxdB(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxdB;
	ret = PhidgetSoundSensor_getMaxdB(h, &maxdB);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxdB;
	}
	return maxdB;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getdBA(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dBA;
	ret = PhidgetSoundSensor_getdBA(h, &dBA);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dBA;
	}
	return dBA;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getdBC(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dBC;
	ret = PhidgetSoundSensor_getdBC(h, &dBC);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dBC;
	}
	return dBC;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getNoiseFloor(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double noiseFloor;
	ret = PhidgetSoundSensor_getNoiseFloor(h, &noiseFloor);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return noiseFloor;
	}
	return noiseFloor;
}

JNIEXPORT jdoubleArray JNICALL Java_com_phidget22_SoundSensorBase_getOctaves(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double octaves[10];
	jdoubleArray joctaves = (*env)->NewDoubleArray(env, 10);
	ret = PhidgetSoundSensor_getOctaves(h, &octaves);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	(*env)->SetDoubleArrayRegion(env, joctaves, 0, (jsize)10, octaves);
	return joctaves;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getSPLChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double SPLChangeTrigger;
	ret = PhidgetSoundSensor_getSPLChangeTrigger(h, &SPLChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return SPLChangeTrigger;
	}
	return SPLChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_SoundSensorBase_setSPLChangeTrigger(JNIEnv * env, jobject obj, jdouble SPLChangeTrigger) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSoundSensor_setSPLChangeTrigger(h, (double)SPLChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getMinSPLChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minSPLChangeTrigger;
	ret = PhidgetSoundSensor_getMinSPLChangeTrigger(h, &minSPLChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minSPLChangeTrigger;
	}
	return minSPLChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SoundSensorBase_getMaxSPLChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxSPLChangeTrigger;
	ret = PhidgetSoundSensor_getMaxSPLChangeTrigger(h, &maxSPLChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxSPLChangeTrigger;
	}
	return maxSPLChangeTrigger;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_SoundSensorBase_getSPLRange(JNIEnv * env, jobject obj) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetSoundSensor_SPLRange SPLRange;
	if (SPLRange_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/SPLRange");
	ret = PhidgetSoundSensor_getSPLRange(h, &SPLRange);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, SPLRange_class, SPLRange_getEnum_mid, SPLRange);
}

JNIEXPORT void JNICALL Java_com_phidget22_SoundSensorBase_setSPLRange(JNIEnv * env, jobject obj, jobject SPLRange) {
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (SPLRange_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/SPLRange");
	ret = PhidgetSoundSensor_setSPLRange(h, (PhidgetSoundSensor_SPLRange)(*env)->CallIntMethod(env, SPLRange, SPLRange_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

static void CCONV SPLChange_handler(PhidgetSoundSensorHandle h, void *arg, double dB, double dBA, double dBC, const double octaves[10]) {
	jobject SPLChangeEv;
	JNIEnv *env;
	jobject obj;
	jdoubleArray octavesArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	octavesArr = (*env)->NewDoubleArray(env, (jsize)10);
	(*env)->SetDoubleArrayRegion(env, octavesArr, 0, (jsize)10, octaves);

	if ((SPLChangeEv = (*env)->NewObject(env, SPLChangeEvent_class, SPLChangeEvent_cons, obj, dB, dBA, dBC, octavesArr)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireSPLChange_mid, SPLChangeEv);
		(*env)->DeleteLocalRef(env, SPLChangeEv);
	}
	(*env)->DeleteLocalRef(env, octavesArr);
}

JNIEXPORT void JNICALL Java_com_phidget22_SoundSensorBase_enableSPLChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (SPLChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/SoundSensorSPLChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeSPLChangeHandler_fid, b);
	PhidgetSoundSensorHandle h = (PhidgetSoundSensorHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetSoundSensor_setOnSPLChangeHandler(h, b ? SPLChange_handler : NULL, (void *)(uintptr_t) gr);
}
