/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_SpatialBase.h"

static jclass spatialbase_class;
jclass spatial_class;
jmethodID spatial_cons;

static jclass spatialDataEvent_class;
static jmethodID fireSpatialData_mid	;
static jmethodID spatialDataEvent_cons;
static jfieldID nativeSpatialDataHandler_fid;

static jclass algorithmDataEvent_class;
static jmethodID fireAlgorithmData_mid	;
static jmethodID algorithmDataEvent_cons;
static jfieldID nativeAlgorithmDataHandler_fid;

void com_phidget22_SpatialBase_OnLoad(JNIEnv *env) {
	if (!(spatial_class = (*env)->FindClass(env, "com/phidget22/Spatial"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(spatial_class = (jclass)(*env)->NewGlobalRef(env, spatial_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef spatial_class");
	if (!(spatial_cons = (*env)->GetMethodID(env, spatial_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from spatial_class");

	if (!(spatialbase_class = (*env)->FindClass(env, "com/phidget22/SpatialBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/SpatialBase");
	if (!(spatialbase_class = (jclass)(*env)->NewGlobalRef(env, spatialbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef spatialbase_class");

	if ((spatialDataEvent_class = (*env)->FindClass(env, "com/phidget22/SpatialSpatialDataEvent"))) {
		if (!(spatialDataEvent_class = (jclass)(*env)->NewGlobalRef(env, spatialDataEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref SpatialDataEvent_class");
		if (!(fireSpatialData_mid = (*env)->GetMethodID(env, spatialbase_class, "fireSpatialData", "(Lcom/phidget22/SpatialSpatialDataEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireSpatialData");
		if (!(spatialDataEvent_cons = (*env)->GetMethodID(env, spatialDataEvent_class, "<init>", "(Lcom/phidget22/Spatial;[D[D[DD)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from SpatialDataEvent_class");
		if (!(nativeSpatialDataHandler_fid = (*env)->GetFieldID(env, spatialbase_class, "nativeSpatialDataHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeSpatialDataHandler from spatialbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((algorithmDataEvent_class = (*env)->FindClass(env, "com/phidget22/SpatialAlgorithmDataEvent"))) {
		if (!(algorithmDataEvent_class = (jclass)(*env)->NewGlobalRef(env, algorithmDataEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref AlgorithmDataEvent_class");
		if (!(fireAlgorithmData_mid = (*env)->GetMethodID(env, spatialbase_class, "fireAlgorithmData", "(Lcom/phidget22/SpatialAlgorithmDataEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireAlgorithmData");
		if (!(algorithmDataEvent_cons = (*env)->GetMethodID(env, algorithmDataEvent_class, "<init>", "(Lcom/phidget22/Spatial;[DD)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from AlgorithmDataEvent_class");
		if (!(nativeAlgorithmDataHandler_fid = (*env)->GetFieldID(env, spatialbase_class, "nativeAlgorithmDataHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeAlgorithmDataHandler from spatialbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_SpatialBase_create(JNIEnv * env, jclass obj) {
	PhidgetSpatialHandle phid;
	int error; 
	if ((error = PhidgetSpatial_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_setAHRSParameters(JNIEnv * env, jobject obj, jdouble angularVelocityThreshold, jdouble angularVelocityDeltaThreshold, jdouble accelerationThreshold, jdouble magTime, jdouble accelTime, jdouble biasTime) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_setAHRSParameters(h, (double)angularVelocityThreshold, (double)angularVelocityDeltaThreshold, (double)accelerationThreshold, (double)magTime, (double)accelTime, (double)biasTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_SpatialBase_getAlgorithm(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_SpatialAlgorithm algorithm;
	if (SpatialAlgorithm_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/SpatialAlgorithm");
	ret = PhidgetSpatial_getAlgorithm(h, &algorithm);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, SpatialAlgorithm_class, SpatialAlgorithm_getEnum_mid, algorithm);
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_setAlgorithm(JNIEnv * env, jobject obj, jobject algorithm) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (SpatialAlgorithm_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/SpatialAlgorithm");
	ret = PhidgetSpatial_setAlgorithm(h, (Phidget_SpatialAlgorithm)(*env)->CallIntMethod(env, algorithm, SpatialAlgorithm_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SpatialBase_getAlgorithmMagnetometerGain(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double algorithmMagnetometerGain;
	ret = PhidgetSpatial_getAlgorithmMagnetometerGain(h, &algorithmMagnetometerGain);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return algorithmMagnetometerGain;
	}
	return algorithmMagnetometerGain;
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_setAlgorithmMagnetometerGain(JNIEnv * env, jobject obj, jdouble algorithmMagnetometerGain) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_setAlgorithmMagnetometerGain(h, (double)algorithmMagnetometerGain);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_SpatialBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetSpatial_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_SpatialBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetSpatial_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_SpatialBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetSpatial_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SpatialBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetSpatial_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SpatialBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetSpatial_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_SpatialBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetSpatial_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_SpatialBase_getEulerAngles(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetSpatial_SpatialEulerAngles eulerAngles;
	ret = PhidgetSpatial_getEulerAngles(h, &eulerAngles);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return PhidgetSpatial_SpatialEulerAngles_to_jobject(env, &eulerAngles);
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_SpatialBase_getHeatingEnabled(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int heatingEnabled;
	ret = PhidgetSpatial_getHeatingEnabled(h, &heatingEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return heatingEnabled;
	}
	return heatingEnabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_setHeatingEnabled(JNIEnv * env, jobject obj, jboolean heatingEnabled) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_setHeatingEnabled(h, (int)heatingEnabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_setMagnetometerCorrectionParameters(JNIEnv * env, jobject obj, jdouble magneticField, jdouble offset0, jdouble offset1, jdouble offset2, jdouble gain0, jdouble gain1, jdouble gain2, jdouble T0, jdouble T1, jdouble T2, jdouble T3, jdouble T4, jdouble T5) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_setMagnetometerCorrectionParameters(h, (double)magneticField, (double)offset0, (double)offset1, (double)offset2, (double)gain0, (double)gain1, (double)gain2, (double)T0, (double)T1, (double)T2, (double)T3, (double)T4, (double)T5);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_SpatialBase_getQuaternion(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetSpatial_SpatialQuaternion quaternion;
	ret = PhidgetSpatial_getQuaternion(h, &quaternion);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return PhidgetSpatial_SpatialQuaternion_to_jobject(env, &quaternion);
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_resetMagnetometerCorrectionParameters(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_resetMagnetometerCorrectionParameters(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_saveMagnetometerCorrectionParameters(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_saveMagnetometerCorrectionParameters(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_zeroAlgorithm(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_zeroAlgorithm(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_zeroGyro(JNIEnv * env, jobject obj) {
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetSpatial_zeroGyro(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

static void CCONV algorithmData_handler(PhidgetSpatialHandle h, void *arg, const double quaternion[4], double timestamp) {
	jobject algorithmDataEv;
	JNIEnv *env;
	jobject obj;
	jdoubleArray quaternionArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	quaternionArr = (*env)->NewDoubleArray(env, (jsize)4);
	(*env)->SetDoubleArrayRegion(env, quaternionArr, 0, (jsize)4, quaternion);

	if ((algorithmDataEv = (*env)->NewObject(env, algorithmDataEvent_class, algorithmDataEvent_cons, obj, quaternionArr, timestamp)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireAlgorithmData_mid, algorithmDataEv);
		(*env)->DeleteLocalRef(env, algorithmDataEv);
	}
	(*env)->DeleteLocalRef(env, quaternionArr);
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_enableAlgorithmDataEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (algorithmDataEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/SpatialAlgorithmDataEvent");
	jlong gr = updateGlobalRef(env, obj, nativeAlgorithmDataHandler_fid, b);
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetSpatial_setOnAlgorithmDataHandler(h, b ? algorithmData_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV spatialData_handler(PhidgetSpatialHandle h, void *arg, const double acceleration[3], const double angularRate[3], const double magneticField[3], double timestamp) {
	jobject spatialDataEv;
	JNIEnv *env;
	jobject obj;
	jdoubleArray accelerationArr;
	jdoubleArray angularRateArr;
	jdoubleArray magneticFieldArr;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	accelerationArr = (*env)->NewDoubleArray(env, (jsize)3);
	(*env)->SetDoubleArrayRegion(env, accelerationArr, 0, (jsize)3, acceleration);
	angularRateArr = (*env)->NewDoubleArray(env, (jsize)3);
	(*env)->SetDoubleArrayRegion(env, angularRateArr, 0, (jsize)3, angularRate);
	magneticFieldArr = (*env)->NewDoubleArray(env, (jsize)3);
	(*env)->SetDoubleArrayRegion(env, magneticFieldArr, 0, (jsize)3, magneticField);

	if ((spatialDataEv = (*env)->NewObject(env, spatialDataEvent_class, spatialDataEvent_cons, obj, accelerationArr, angularRateArr, magneticFieldArr, timestamp)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireSpatialData_mid, spatialDataEv);
		(*env)->DeleteLocalRef(env, spatialDataEv);
	}
	(*env)->DeleteLocalRef(env, accelerationArr);
	(*env)->DeleteLocalRef(env, angularRateArr);
	(*env)->DeleteLocalRef(env, magneticFieldArr);
}

JNIEXPORT void JNICALL Java_com_phidget22_SpatialBase_enableSpatialDataEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (spatialDataEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/SpatialSpatialDataEvent");
	jlong gr = updateGlobalRef(env, obj, nativeSpatialDataHandler_fid, b);
	PhidgetSpatialHandle h = (PhidgetSpatialHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetSpatial_setOnSpatialDataHandler(h, b ? spatialData_handler : NULL, (void *)(uintptr_t) gr);
}
