/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_VoltageInputBase.h"

static jclass voltageInputbase_class;
jclass voltageInput_class;
jmethodID voltageInput_cons;

static jclass voltageChangeEvent_class;
static jmethodID fireVoltageChange_mid	;
static jmethodID voltageChangeEvent_cons;
static jfieldID nativeVoltageChangeHandler_fid;

static jclass sensorChangeEvent_class;
static jmethodID fireSensorChange_mid	;
static jmethodID sensorChangeEvent_cons;
static jfieldID nativeSensorChangeHandler_fid;

void com_phidget22_VoltageInputBase_OnLoad(JNIEnv *env) {
	if (!(voltageInput_class = (*env)->FindClass(env, "com/phidget22/VoltageInput"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(voltageInput_class = (jclass)(*env)->NewGlobalRef(env, voltageInput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef voltageInput_class");
	if (!(voltageInput_cons = (*env)->GetMethodID(env, voltageInput_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from voltageInput_class");

	if (!(voltageInputbase_class = (*env)->FindClass(env, "com/phidget22/VoltageInputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageInputBase");
	if (!(voltageInputbase_class = (jclass)(*env)->NewGlobalRef(env, voltageInputbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef voltageInputbase_class");

	if ((voltageChangeEvent_class = (*env)->FindClass(env, "com/phidget22/VoltageInputVoltageChangeEvent"))) {
		if (!(voltageChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, voltageChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref VoltageChangeEvent_class");
		if (!(fireVoltageChange_mid = (*env)->GetMethodID(env, voltageInputbase_class, "fireVoltageChange", "(Lcom/phidget22/VoltageInputVoltageChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireVoltageChange");
		if (!(voltageChangeEvent_cons = (*env)->GetMethodID(env, voltageChangeEvent_class, "<init>", "(Lcom/phidget22/VoltageInput;D)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from VoltageChangeEvent_class");
		if (!(nativeVoltageChangeHandler_fid = (*env)->GetFieldID(env, voltageInputbase_class, "nativeVoltageChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeVoltageChangeHandler from voltageInputbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}

	if ((sensorChangeEvent_class = (*env)->FindClass(env, "com/phidget22/VoltageInputSensorChangeEvent"))) {
		if (!(sensorChangeEvent_class = (jclass)(*env)->NewGlobalRef(env, sensorChangeEvent_class)))
			JNI_ABORT_STDERR("Couldn't create global ref SensorChangeEvent_class");
		if (!(fireSensorChange_mid = (*env)->GetMethodID(env, voltageInputbase_class, "fireSensorChange", "(Lcom/phidget22/VoltageInputSensorChangeEvent;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID fireSensorChange");
		if (!(sensorChangeEvent_cons = (*env)->GetMethodID(env, sensorChangeEvent_class, "<init>", "(Lcom/phidget22/VoltageInput;DLcom/phidget22/UnitInfo;)V")))
			JNI_ABORT_STDERR("Couldn't get method ID <init> from SensorChangeEvent_class");
		if (!(nativeSensorChangeHandler_fid = (*env)->GetFieldID(env, voltageInputbase_class, "nativeSensorChangeHandler", "J")))
			JNI_ABORT_STDERR("Couldn't get Field ID nativeSensorChangeHandler from voltageInputbase_class");
	} else {
		(*env)->ExceptionClear(env);
	}
}
JNIEXPORT jlong JNICALL Java_com_phidget22_VoltageInputBase_create(JNIEnv * env, jclass obj) {
	PhidgetVoltageInputHandle phid;
	int error; 
	if ((error = PhidgetVoltageInput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT jint JNICALL Java_com_phidget22_VoltageInputBase_getDataInterval(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t dataInterval;
	ret = PhidgetVoltageInput_getDataInterval(h, &dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataInterval;
	}
	return dataInterval;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageInputBase_setDataInterval(JNIEnv * env, jobject obj, jint dataInterval) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageInput_setDataInterval(h, (uint32_t)dataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_VoltageInputBase_getMinDataInterval(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minDataInterval;
	ret = PhidgetVoltageInput_getMinDataInterval(h, &minDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataInterval;
	}
	return minDataInterval;
}

JNIEXPORT jint JNICALL Java_com_phidget22_VoltageInputBase_getMaxDataInterval(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxDataInterval;
	ret = PhidgetVoltageInput_getMaxDataInterval(h, &maxDataInterval);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataInterval;
	}
	return maxDataInterval;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getDataRate(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double dataRate;
	ret = PhidgetVoltageInput_getDataRate(h, &dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return dataRate;
	}
	return dataRate;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageInputBase_setDataRate(JNIEnv * env, jobject obj, jdouble dataRate) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageInput_setDataRate(h, (double)dataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getMinDataRate(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minDataRate;
	ret = PhidgetVoltageInput_getMinDataRate(h, &minDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minDataRate;
	}
	return minDataRate;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getMaxDataRate(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxDataRate;
	ret = PhidgetVoltageInput_getMaxDataRate(h, &maxDataRate);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxDataRate;
	}
	return maxDataRate;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_VoltageInputBase_getPowerSupply(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_PowerSupply powerSupply;
	if (PowerSupply_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerSupply");
	ret = PhidgetVoltageInput_getPowerSupply(h, &powerSupply);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, PowerSupply_class, PowerSupply_getEnum_mid, powerSupply);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageInputBase_setPowerSupply(JNIEnv * env, jobject obj, jobject powerSupply) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (PowerSupply_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/PowerSupply");
	ret = PhidgetVoltageInput_setPowerSupply(h, (Phidget_PowerSupply)(*env)->CallIntMethod(env, powerSupply, PowerSupply_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_VoltageInputBase_getSensorType(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetVoltageInput_SensorType sensorType;
	if (VoltageSensorType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageSensorType");
	ret = PhidgetVoltageInput_getSensorType(h, &sensorType);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, VoltageSensorType_class, VoltageSensorType_getEnum_mid, sensorType);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageInputBase_setSensorType(JNIEnv * env, jobject obj, jobject sensorType) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (VoltageSensorType_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageSensorType");
	ret = PhidgetVoltageInput_setSensorType(h, (PhidgetVoltageInput_SensorType)(*env)->CallIntMethod(env, sensorType, VoltageSensorType_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jobject JNICALL Java_com_phidget22_VoltageInputBase_getSensorUnit(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	Phidget_UnitInfo sensorUnit;
	ret = PhidgetVoltageInput_getSensorUnit(h, &sensorUnit);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return Phidget_UnitInfo_to_jobject(env, &sensorUnit);
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getSensorValue(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double sensorValue;
	ret = PhidgetVoltageInput_getSensorValue(h, &sensorValue);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return sensorValue;
	}
	return sensorValue;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getSensorValueChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double sensorValueChangeTrigger;
	ret = PhidgetVoltageInput_getSensorValueChangeTrigger(h, &sensorValueChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return sensorValueChangeTrigger;
	}
	return sensorValueChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageInputBase_setSensorValueChangeTrigger(JNIEnv * env, jobject obj, jdouble sensorValueChangeTrigger) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageInput_setSensorValueChangeTrigger(h, (double)sensorValueChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getVoltage(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double voltage;
	ret = PhidgetVoltageInput_getVoltage(h, &voltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return voltage;
	}
	return voltage;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getMinVoltage(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minVoltage;
	ret = PhidgetVoltageInput_getMinVoltage(h, &minVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minVoltage;
	}
	return minVoltage;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getMaxVoltage(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxVoltage;
	ret = PhidgetVoltageInput_getMaxVoltage(h, &maxVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxVoltage;
	}
	return maxVoltage;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getVoltageChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double voltageChangeTrigger;
	ret = PhidgetVoltageInput_getVoltageChangeTrigger(h, &voltageChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return voltageChangeTrigger;
	}
	return voltageChangeTrigger;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageInputBase_setVoltageChangeTrigger(JNIEnv * env, jobject obj, jdouble voltageChangeTrigger) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageInput_setVoltageChangeTrigger(h, (double)voltageChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getMinVoltageChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minVoltageChangeTrigger;
	ret = PhidgetVoltageInput_getMinVoltageChangeTrigger(h, &minVoltageChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minVoltageChangeTrigger;
	}
	return minVoltageChangeTrigger;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageInputBase_getMaxVoltageChangeTrigger(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxVoltageChangeTrigger;
	ret = PhidgetVoltageInput_getMaxVoltageChangeTrigger(h, &maxVoltageChangeTrigger);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxVoltageChangeTrigger;
	}
	return maxVoltageChangeTrigger;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_VoltageInputBase_getVoltageRange(JNIEnv * env, jobject obj) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetVoltageInput_VoltageRange voltageRange;
	if (VoltageRange_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageRange");
	ret = PhidgetVoltageInput_getVoltageRange(h, &voltageRange);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, VoltageRange_class, VoltageRange_getEnum_mid, voltageRange);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageInputBase_setVoltageRange(JNIEnv * env, jobject obj, jobject voltageRange) {
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (VoltageRange_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageRange");
	ret = PhidgetVoltageInput_setVoltageRange(h, (PhidgetVoltageInput_VoltageRange)(*env)->CallIntMethod(env, voltageRange, VoltageRange_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

static void CCONV sensorChange_handler(PhidgetVoltageInputHandle h, void *arg, double sensorValue, Phidget_UnitInfo *sensorUnit) {
	jobject sensorChangeEv;
	JNIEnv *env;
	jobject obj;
	jobject sensorUnitObj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;
	sensorUnitObj = Phidget_UnitInfo_to_jobject(env, sensorUnit);

	if ((sensorChangeEv = (*env)->NewObject(env, sensorChangeEvent_class, sensorChangeEvent_cons, obj, sensorValue, sensorUnitObj)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireSensorChange_mid, sensorChangeEv);
		(*env)->DeleteLocalRef(env, sensorChangeEv);
	}
	(*env)->DeleteLocalRef(env, sensorUnitObj);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageInputBase_enableSensorChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (sensorChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageInputSensorChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeSensorChangeHandler_fid, b);
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetVoltageInput_setOnSensorChangeHandler(h, b ? sensorChange_handler : NULL, (void *)(uintptr_t) gr);
}

static void CCONV voltageChange_handler(PhidgetVoltageInputHandle h, void *arg, double voltage) {
	jobject voltageChangeEv;
	JNIEnv *env;
	jobject obj;

	if ((*ph_vm)->AttachCurrentThreadAsDaemon(ph_vm, (JNIEnvPtr)&env, NULL))
		JNI_ABORT_STDERR("Couldn't AttachCurrentThreadAsDaemon");

	obj = (jobject)arg;

	if ((voltageChangeEv = (*env)->NewObject(env, voltageChangeEvent_class, voltageChangeEvent_cons, obj, voltage)) != 0) {
		(*env)->CallVoidMethod(env, obj, fireVoltageChange_mid, voltageChangeEv);
		(*env)->DeleteLocalRef(env, voltageChangeEv);
	}
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageInputBase_enableVoltageChangeEvents(JNIEnv * env, jobject obj, jboolean b) {
	if (voltageChangeEvent_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageInputVoltageChangeEvent");
	jlong gr = updateGlobalRef(env, obj, nativeVoltageChangeHandler_fid, b);
	PhidgetVoltageInputHandle h = (PhidgetVoltageInputHandle)( uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetVoltageInput_setOnVoltageChangeHandler(h, b ? voltageChange_handler : NULL, (void *)(uintptr_t) gr);
}
