/* DO NOT EDIT THIS FILE - it is machine generated */

/*
 * This file is part of libphidget22java
 *
 * Copyright 2017 Phidgets Inc <patrick@phidgets.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, see
 * <http://www.gnu.org/licenses/>
 */

#include "phidget_jni.h"
#include "com_phidget22_VoltageOutputBase.h"

static jclass voltageOutputbase_class;
jclass voltageOutput_class;
jmethodID voltageOutput_cons;

void com_phidget22_VoltageOutputBase_OnLoad(JNIEnv *env) {
	if (!(voltageOutput_class = (*env)->FindClass(env, "com/phidget22/VoltageOutput"))) {
		(*env)->ExceptionClear(env);
		return;
	}
	if (!(voltageOutput_class = (jclass)(*env)->NewGlobalRef(env, voltageOutput_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef voltageOutput_class");
	if (!(voltageOutput_cons = (*env)->GetMethodID(env, voltageOutput_class, "<init>", "(J)V")))
		JNI_ABORT_STDERR("Couldn't get Method ID <init> from voltageOutput_class");

	if (!(voltageOutputbase_class = (*env)->FindClass(env, "com/phidget22/VoltageOutputBase")))
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageOutputBase");
	if (!(voltageOutputbase_class = (jclass)(*env)->NewGlobalRef(env, voltageOutputbase_class)))
		JNI_ABORT_STDERR("Couldn't create NewGlobalRef voltageOutputbase_class");
}
JNIEXPORT jlong JNICALL Java_com_phidget22_VoltageOutputBase_create(JNIEnv * env, jclass obj) {
	PhidgetVoltageOutputHandle phid;
	int error; 
	if ((error = PhidgetVoltageOutput_create(&phid)) != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(error);
		return 0;
	}
	return (jlong)(uintptr_t)phid;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_setEnabled(JNIEnv * env, jobject obj, jboolean enabled) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageOutput_setEnabled(h, (int)enabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jboolean JNICALL Java_com_phidget22_VoltageOutputBase_getEnabled(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	int enabled;
	ret = PhidgetVoltageOutput_getEnabled(h, &enabled);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return enabled;
	}
	return enabled;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_enableFailsafe(JNIEnv * env, jobject obj, jint failsafeTime) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageOutput_enableFailsafe(h, (uint32_t)failsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jint JNICALL Java_com_phidget22_VoltageOutputBase_getMinFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t minFailsafeTime;
	ret = PhidgetVoltageOutput_getMinFailsafeTime(h, &minFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minFailsafeTime;
	}
	return minFailsafeTime;
}

JNIEXPORT jint JNICALL Java_com_phidget22_VoltageOutputBase_getMaxFailsafeTime(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	uint32_t maxFailsafeTime;
	ret = PhidgetVoltageOutput_getMaxFailsafeTime(h, &maxFailsafeTime);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxFailsafeTime;
	}
	return maxFailsafeTime;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_resetFailsafe(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageOutput_resetFailsafe(h);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageOutputBase_getVoltage(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double voltage;
	ret = PhidgetVoltageOutput_getVoltage(h, &voltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return voltage;
	}
	return voltage;
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_setVoltage__DLcom_phidget22_AsyncListener_2(JNIEnv * env, jobject obj, jdouble voltage, jobject asyncHandler) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	jclass obj_class = (*env)->FindClass(env, "Ljava/lang/Object;");
	jobjectArray arr = (*env)->NewObjectArray(env, 2, obj_class, NULL);
	(*env)->SetObjectArrayElement(env, arr, 0, obj);
	(*env)->SetObjectArrayElement(env, arr, 1, asyncHandler);
	PhidgetVoltageOutput_setVoltage_async(h, (double)voltage, asyncCallbackHandler, (*env)->NewGlobalRef(env, arr));
	(*env)->DeleteLocalRef(env, arr);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_setVoltage__D(JNIEnv * env, jobject obj, jdouble voltage) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	ret = PhidgetVoltageOutput_setVoltage(h, (double)voltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageOutputBase_getMinVoltage(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double minVoltage;
	ret = PhidgetVoltageOutput_getMinVoltage(h, &minVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return minVoltage;
	}
	return minVoltage;
}

JNIEXPORT jdouble JNICALL Java_com_phidget22_VoltageOutputBase_getMaxVoltage(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	double maxVoltage;
	ret = PhidgetVoltageOutput_getMaxVoltage(h, &maxVoltage);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return maxVoltage;
	}
	return maxVoltage;
}

JNIEXPORT jobject JNICALL Java_com_phidget22_VoltageOutputBase_getVoltageOutputRange(JNIEnv * env, jobject obj) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	PhidgetVoltageOutput_VoltageOutputRange voltageOutputRange;
	if (VoltageOutputRange_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageOutputRange");
	ret = PhidgetVoltageOutput_getVoltageOutputRange(h, &voltageOutputRange);
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return NULL;
	}
	return (*env)->CallStaticObjectMethod(env, VoltageOutputRange_class, VoltageOutputRange_getEnum_mid, voltageOutputRange);
}

JNIEXPORT void JNICALL Java_com_phidget22_VoltageOutputBase_setVoltageOutputRange(JNIEnv * env, jobject obj, jobject voltageOutputRange) {
	PhidgetVoltageOutputHandle h = (PhidgetVoltageOutputHandle)(uintptr_t)(*env)->GetLongField(env, obj, phidget_handle_fid);
	PhidgetReturnCode ret;
	if (VoltageOutputRange_class == NULL)
		JNI_ABORT_STDERR("Couldn't FindClass com/phidget22/VoltageOutputRange");
	ret = PhidgetVoltageOutput_setVoltageOutputRange(h, (PhidgetVoltageOutput_VoltageOutputRange)(*env)->CallIntMethod(env, voltageOutputRange, VoltageOutputRange_getCode_mid));
	if (ret != EPHIDGET_OK) {
		PH_THROW_LAST_ERR(ret);
		return;
	}
}
